(* Copyright (C) 2014, Daniel Wyckoff*)
(*This file is part of BooleanAlgebrasIntro2.

BooleanAlgebrasIntro2 is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

BooleanAlgebrasIntro2 is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BooleanAlgebrasIntro2.  If not, see <http://www.gnu.org/licenses/>.*)

Require Export Arith.

Lemma lt_n_1 : forall (n:nat), n < 1 -> n = 0.
intro n.
destruct n.
intros; reflexivity.
intro h1.
pose proof (lt_pred _ _ h1) as h2.
simpl in h2.
pose proof (lt_n_0 n).
contradiction.
Qed.

Lemma S_compat : forall (m:nat), m + 1 = S m.
intros m'. induction m' as [|m h1]; auto with arith.
pose proof @plus_permute.
rewrite <- h1 at 2.
rewrite h1.
rewrite plus_comm.
rewrite plus_Snm_nSm.
auto with arith.
Qed.



Lemma plus_succ_shift : forall (m n:nat), (m + S n) = S (m + n).
intros m n.
pose proof @plus_permute.
assert (h1:S n = 1 + n). auto with arith.
rewrite h1.
rewrite plus_permute.
rewrite plus_comm.
simpl. auto with sets.
apply S_compat.
Qed.

